import unit4.collectionsLib.*;
import unit4.utilsLib.*;
class testTreeByTravers{
 

  
  public static void postOrder(TreeByTravers<Integer> t){
    if(t!=null){
    postOrder(t.getLeft());
     postOrder(t.getRight());
      System.out.print(t.getInfo()+" ");
    }
  }
  public static int countLeaves(TreeByTravers<Integer> t){
    if(t==null)return 0;
    if(t.isLeaf())return 1;
    return countLeaves(t.getLeft())+countLeaves(t.getRight());
  }
  
  public static int sumNodes(TreeByTravers<Integer> t){
    if(t==null)return 0;
    return t.getInfo()+sumNodes(t.getLeft())+sumNodes(t.getRight());
  }
  public static void main(String[] args){
  // **************** Test for <Integer> tree ***************************
  
  //  PreOrder: 9,6,2,10,4,7,8,5,3,1,0 
  //    InOrder: 10,2,4,6,9,8,7,3,5,1,0
//      postOrder 10,4,2,6,8,3,0,1,5,7,9 
    
    List<Integer> preOrder=new List<Integer>();
      preOrder.insert(null,0);     preOrder.insert(null,1);     preOrder.insert(null,3);     preOrder.insert(null,5);
           preOrder.insert(null,8);     preOrder.insert(null,7);     preOrder.insert(null,4);     preOrder.insert(null,10);
           preOrder.insert(null,2);     preOrder.insert(null,6);     preOrder.insert(null,9);   
     // System.out.println(preOrder);  
          
       List<Integer> inOrder=new List<Integer>();
      inOrder.insert(null,0);     inOrder.insert(null,1);     inOrder.insert(null,5);     inOrder.insert(null,3);
           inOrder.insert(null,7);     inOrder.insert(null,8);     inOrder.insert(null,9);     inOrder.insert(null,6);
           inOrder.insert(null,4);     inOrder.insert(null,2);     inOrder.insert(null,10);   
       // System.out.println(inOrder);
       
        List<Integer> postOrder=new List<Integer>();
      postOrder.insert(null,9);     postOrder.insert(null,7);     postOrder.insert(null,5);     postOrder.insert(null,1);
           postOrder.insert(null,0);     postOrder.insert(null,3);     postOrder.insert(null,8);     postOrder.insert(null,6);
           postOrder.insert(null,2);     postOrder.insert(null,4);     postOrder.insert(null,10);   
       // System.out.println(postOrder);  
  
  
   TreeByTravers<Integer> test=new TreeByTravers<Integer>(preOrder,inOrder); 
     BinTreeNode<Integer> t=test.buildPreIn();
     BinTreeUtils.showTree(t,"t: rebuild tree Pre+In from two Lists");
      postOrder(test);
      System.out.println();
      System.out.println("Is leaf="+test.isLeaf());
      System.out.println("Num of Leaves="+countLeaves(test));
      System.out.println("Num of Nodes="+test.countNodes());
      System.out.println("Sum of Nodes="+sumNodes(test));
     
      
      
    TreeByTravers<Integer> test0=new TreeByTravers<Integer>(100);  
    BinTreeNode<Integer> t0=test0.buildPreIn();
    BinTreeUtils.showTree(t0,"t0: rebuild tree Pre+In from one value");
     
     TreeByTravers<Integer> test1=new TreeByTravers<Integer>(null, 200, test0);  
    BinTreeNode<Integer> t1=test1.buildPreIn();
    BinTreeUtils.showTree(t1,"t1: rebuild tree Pre+In from two trees");
    
     TreeByTravers<Integer> test2=new TreeByTravers<Integer>(test,-100, test1); 
      BinTreeNode<Integer> t2=test2.buildPreIn();
      BinTreeUtils.showTree(t2,"t2: rebuild tree Pre+In from two trees");
    
     
      test1.setLeft(test);
      t1=test1.buildPreIn();
       BinTreeUtils.showTree(t1,"t1-new: rebuild tree Pre+In  after setLeft");
       
       test1.setRight(test);
      t1=test1.buildPreIn();
       BinTreeUtils.showTree(t1,"t1-new: rebuild tree Pre+In  after setRight");
  
      test1.setRight(null);
      t1=test1.buildPreIn();
       BinTreeUtils.showTree(t1,"t1-new: rebuild tree Pre+In  after setRight (null)");
// ********** Test for <Character> tree **********************
     // PreOrder: a, b,c,d
      // InOrder:  b,a,c,d
      // PostOrder: b,d,c,a
       List<Character> pO=new List<Character>();
       pO.insert(null,'d'); pO.insert(null,'c'); pO.insert(null,'b'); pO.insert(null,'a');
       
       List<Character> iO=new List<Character>();
       iO.insert(null,'d'); iO.insert(null,'c'); iO.insert(null,'a'); iO.insert(null,'b');
  
        
       TreeByTravers<Character> test10=new TreeByTravers<Character>(pO,iO);      
        BinTreeNode<Character> t10=test10.buildPreIn();
       
  System.out.println("results:");
        System.out.println("PreOrder:  "+BinTreeUtils.preOrderTraversal(t10));  
        System.out.println("InOrder:     "+BinTreeUtils.inOrderTraversal(t10));
        System.out.println("PostOrder: "+BinTreeUtils.postOrderTraversal(t10));           
 }
   }      
    
      